package ColdFront_Siege {
//-------------------------------------------------------------------------------------------- begin ColdFront_Siege package ---***---

//--------------------------------------------------------------------------- siegeGame::initializeWaypointAtObjective ---

function siegeGame::initializeWaypointAtObjective(%game, %object)
{
   // out with the old...jic
   if ( %object.waypoint )
   {
      if ( isObject( %object.waypoint ) )
         %object.waypoint.delete();
      else
         %object.waypoint = "";   
   }

   if(%object.team == %game.offenseTeam)
      %team = %game.offenseTeam;
   else
      %team = (%game.offenseTeam == 1 ? 2 : 1);
	
   ////lets set just one waypoint position for all the main gens - Lagg...
   //if(%object.getGroup() $= nameToId("MainPower"))
   //{
      //%marker = nameToId("MainGenMarker");
      //error("siegeGame::initializeWaypointAtObjective - We Got a MAIN GEN HERE !");

      //%posX = getWord(%marker.getWorldBoxCenter(), 0);
      //%posY = getWord(%marker.getWorldBoxCenter(), 1);
      //%posZ = getWord(%marker.getWorldBoxCenter(), 2);

   //}

   // to make the waypoint look a little prettier we are using the z from
   // position and the x and y from worldBoxCenter
   //else
   //{
      %posX = getWord(%object.getWorldBoxCenter(), 0);
      %posY = getWord(%object.getWorldBoxCenter(), 1);
      %posZ = getWord(%object.position, 2);
   //}

   %append = getTaggedString(%object.getDataBlock().targetTypeTag);

   %object.waypoint = new WayPoint() {
      position = %posX SPC %posY SPC %posZ;
      rotation = "1 0 0 0";
      scale = "1 1 1";
      dataBlock = "WayPointMarker";
      team = %team;
      name = getTaggedString(%object.nameTag) SPC %append;
      };

   MissionCleanup.add(%object.waypoint);
}

//------------------------------------------------------------------------------------------------ SiegeGame::gameOver ---

function SiegeGame::gameOver( %game )
{	
   deactivatePackage(ColdFront_Siege);
   error("SiegeGame::gameOver - deacitavting ColdFront_Siege package");
   SiegeGame::gameOver( %game );
}

//----------------------------------------------------------------------------------------- SiegeGame::missionLoadDone ---

function SiegeGame::missionLoadDone(%game)
{
   Parent::missionLoadDone(%game);

   //call after parent
   Game.defenseTeam = Game.offenseTeam == 1 ? 2 : 1;
}

//---------------------------------------------------------------------------------------------- Generator::onDisabled ---

function Generator::onDisabled(%data, %obj, %prevState)
{
   Parent::onDisabled(%data, %obj, %prevState);
 
   //main generators
   if (%obj.getGroup() $= nameToId("MainPower"))
   {
      if (%obj.getGroup().powerCount == 0)
      {		
         %count = ClientGroup.getCount();
         for (%i = 0; %i < %count; %i++)
         {
            %client = ClientGroup.getObject(%i);
            if( %client.team == %obj.team )
            {
               if (nameToId("ObjectiveGroup").powerCount == 0)
               {
                  messageClient(%client, 'MsgClient', '~wfx/misc/red_alert.wav');
                  bottomPrint(%client, "<color:FF0000>\RED ALERT - Objective Switch Exposed - RED ALERT", 5, 2);
               }
               else
               {
                  messageClient(%client, 'MsgClient', '~wfx/misc/red_alert_short.wav');
                  bottomPrint(%client, "<color:FF5500>\ALERT - Main Generators Destroyed - ALERT", 3, 2);
               }
            }
            else if (%client.team == Game.offenseTeam)
            {
               if (nameToId("ObjectiveGroup").powerCount == 0)
               {
                  messageClient(%client, 'MsgClient', '~wfx/Bonuses/Nouns/general.wav');
                  bottomPrint(%client, "<color:8BBD03>\Objective Switch Exposed", 5, 2);
               }
               else
               {
                  messageClient(%client, 'MsgClient', '~wfx/Bonuses/Nouns/major.wav');
                  bottomPrint(%client, "<color:8BBD03>\Main Generators Destroyed", 3, 2);
               }
            }
         }
      }
      if (%obj.getGroup().powerCount == 3)
      {		
         %count = ClientGroup.getCount();
         for (%i = 0; %i < %count; %i++)
         {
            %client = ClientGroup.getObject(%i);
            if( %client.team == %obj.team )
            {
               messageClient(%client, 'MsgClient', '~wfx/misc/red_alert_short.wav');
               bottomPrint(%client, "<color:FF5500>\ALERT - Emergency Spawnsphere Activated - ALERT", 3, 2);
            }
         }

         //set the custom spawn weights
         nameToId("DefenseSpawn").indoorWeight = "0";
      }
   }

   // ---------------------------------------------------------------------------------------- reserve generators
   if (%obj == nameToId("Team2generatorLarge3") || %obj ==  nameToId("Team2generatorLarge4"))
   {
      if (nameToId("ObjectiveGroup").powerCount == 0)
      {
      
         //if the reserve generators was destroyed	
         %count = ClientGroup.getCount();
         for (%i = 0; %i < %count; %i++)
         {
            %client = ClientGroup.getObject(%i);
            if( %client.team == %obj.team )
            {
               if (nameToId("MainPower").powerCount == 0)
               {
                  messageClient(%client, 'MsgClient', '~wfx/misc/red_alert.wav');
                  bottomPrint(%client, "<color:FF0000>\RED ALERT - Objective Switch Exposed - RED ALERT", 5, 2);
               }
               else
               {
                  messageClient(%client, 'MsgClient', '~wfx/misc/red_alert_short.wav');
                  bottomPrint(%client, "<color:FF5500>\ALERT - Reserve Generators Destroyed - ALERT", 3, 2);
               }
            }
            else if (%client.team == Game.offenseTeam)
            {
               if (nameToId("MainPower").powerCount == 0)
               {
                  messageClient(%client, 'MsgClient', '~wfx/Bonuses/Nouns/general.wav');
                  bottomPrint(%client, "<color:8BBD03>\Objective Switch Exposed", 5, 2);
               }
               else
               {
                  messageClient(%client, 'MsgClient', '~wfx/Bonuses/Nouns/major.wav');
                  bottomPrint(%client, "<color:8BBD03>\Reserve Generators Destroyed", 3, 2);
               }
            }
         }
      }
   }

   // ----------------------------------------------------------------------------------------- entrance ff gens
   if (%obj == nameToId("Team2generatorLarge1") || %obj ==  nameToId("Team2generatorLarge2"))
   {
      //if the entrance ff generators were destroyed
      if (nameToId("EntranceFFGroup").powerCount == 0)
      {
         %count = ClientGroup.getCount();
         for (%i = 0; %i < %count; %i++)
         {
            %client = ClientGroup.getObject(%i);
            if( %client.team == %obj.team )
            {
               messageClient(%client, 'MsgClient', '~wfx/misc/red_alert_short.wav');
               bottomPrint(%client, "<color:FFFF00>\WARNING - Entrance Force Fields Compromised - WARNING", 2, 2);
            }
            else if (%client.team == Game.offenseTeam)
            {
               messageClient(%client, 'MsgClient', '~wfx/Bonuses/Nouns/captain.wav');
               bottomPrint(%client, "<color:8BBD03>\Entrance Force Fields Compromised", 2, 2);
            }
         }
      }
   }
}

//----------------------------------------------------------------------------------------------- Generator::onEnabled ---

function Generator::onEnabled(%data, %obj, %prevState)
{
   Parent::onEnabled(%data, %obj, %prevState);

   //main generators
   if (%obj.getGroup() $= nameToId("MainPower"))
   {
      if (%obj.getGroup().powerCount < 2)
      {		
         %count = ClientGroup.getCount();
         for (%i = 0; %i < %count; %i++)
         {
            %client = ClientGroup.getObject(%i);
            if( %client.team == %obj.team )
            {
               //messageClient(%client, 'MsgClient', '~wfx/misc/red_alert_short.wav');
               bottomPrint(%client, "<color:8BBD03>\Main Generators Restored", 3, 2);
            }
            else if (%client.team == Game.offenseTeam)
            {
               //messageClient(%client, 'MsgClient', '~wfx/Bonuses/Nouns/major.wav');
               bottomPrint(%client, "<color:FFFF00>\Main Generators Restored", 3, 2);
            }
         }
      }
      if (%obj.getGroup().powerCount == 4)
      {		
         %count = ClientGroup.getCount();
         for (%i = 0; %i < %count; %i++)
         {
            %client = ClientGroup.getObject(%i);
            if( %client.team == %obj.team )
            {
               //messageClient(%client, 'MsgClient', '~wfx/misc/red_alert_short.wav');
               bottomPrint(%client, "<color:8BBD03>\Primary Spawnsphere Restored", 3, 2);
            }
         }

         //set the custom spawn weights
         nameToId("DefenseSpawn").indoorWeight = "100";
      }
   }
   
   // ---------------------------------------------------------------------------------------- reserve generators
   if (%obj == nameToId("Team2generatorLarge3") || %obj ==  nameToId("Team2generatorLarge4"))
   {
      if (nameToId("ObjectiveGroup").powerCount < 2)
      {
      
         //if the reserve generators was destroyed	
         %count = ClientGroup.getCount();
         for (%i = 0; %i < %count; %i++)
         {
            %client = ClientGroup.getObject(%i);
            if( %client.team == %obj.team )
            {
               //messageClient(%client, 'MsgClient', '~wfx/misc/red_alert_short.wav');
               //bottomPrint(%client, "<color:FF5500>\- Reserve Generators Restored -", 3, 2);
               bottomPrint(%client, "<color:8BBD03>\Reserve Generators Restored", 3, 2);
            }
            else if (%client.team == Game.offenseTeam)
            {
               //messageClient(%client, 'MsgClient', '~wfx/Bonuses/Nouns/major.wav');
               bottomPrint(%client, "<color:FF5500>\Reserve Generators Restored", 3, 2);
            }
         }
      }
   }
   // -------------------------------------------------------------------------------------------- entrance ff generators
   if (%obj == nameToId("Team2generatorLarge1") || %obj ==  nameToId("Team2generatorLarge2"))
   {
      //if the entrance ff generators were restored
      if (nameToId("EntranceFFGroup").powerCount < 2)
      {	
         %count = ClientGroup.getCount();
         for (%i = 0; %i < %count; %i++)
         {
            %client = ClientGroup.getObject(%i);
            if( %client.team == %obj.team )
               bottomPrint(%client, "<color:8BBD03>\Entrance Force Fields Restored", 3, 2);
            else if (%client.team == Game.offenseTeam)
               bottomPrint(%client, "<color:FF5500>\Entrance Force Fields Restored", 3, 2);
         }
      }
   }
}

//------------------------------------------------------------------------------------------------ SiegeGame::halftime ---

function SiegeGame::halftime(%game, %reason)
{
   //reset the custom spawn weights
   nameToId("DefenseSpawn").indoorWeight = "100";

   Parent::halftime(%game, %reason);

   //clear bottom print messages
   clearBottomPrintAll();

   error("SiegeGame::halftime - Resetting Indoor Spawn and clearing Bottom Print Messages");
}

//-------------------------------------------------------------------------------------------- SiegeGame::halftimeOver ---

function SiegeGame::halftimeOver( %game )
{
   // drop all players into mission
   %game.dropPlayers();

   //setup the AI for the second half
   %game.aiHalfTime();
   
   // start the mission again (release players)
   %game.halfTimeCountDown( 0 );

   //redo the objective waypoints
   %game.findObjectiveWaypoints();

   //set up ai vehicle functions for second half - Lagg... 10-2-2003   
   SweepForPads(NameToID(MissionGroup));
}

//----------------------------------------------------------------------------------- SiegeGame::objectSwapVehiclePads ---

function SiegeGame::objectSwapVehiclePads(%game, %this)
{
   %defTeam = %game.offenseTeam == 1 ? 2 : 1;

   if(%this.getDatablock().getName() $= "StationVehicle")
   {
      if(%this.getTarget() != -1)
      {
         // swap the teams of both the vehicle pad and the vehicle station
         if(getTargetSensorGroup(%this.getTarget()) == %game.offenseTeam)
         {
            setTargetSensorGroup(%this.getTarget(), %defTeam);
            %this.team = %defTeam;
            setTargetSensorGroup(%this.pad.getTarget(), %defTeam);
            %this.pad.team = %defTeam;
            // z0dd - ZOD, 4/20/02. Switch the teleporter too.
            setTargetSensorGroup(%this.teleporter.getTarget(), %defTeam);
            %this.teleporter.team = %defTeam;
         }
         else if(getTargetSensorGroup(%this.getTarget()) == %defTeam)
         {
            setTargetSensorGroup(%this.getTarget(), %game.offenseTeam);
            %this.team = %game.offenseTeam;
            setTargetSensorGroup(%this.pad.getTarget(), %game.offenseTeam);
            %this.pad.team = %game.offenseTeam;
            // z0dd - ZOD, 4/20/02. Switch the teleporter too.
            setTargetSensorGroup(%this.teleporter.getTarget(), %game.offenseTeam);
            %this.teleporter.team = %game.offenseTeam;
         }
      }
   }
}

//---------------------------------------------------------------------------------------- SiegeGame::vehicleDestroyed ---

//siege game spam fix
function SiegeGame::vehicleDestroyed(%game, %vehicle, %destroyer)
{
  //needed to prevent Siege Game consol spam - Lagg... 11-12-2003   
}

//-------------------------------------------------------------------------------------- StaticShapeData::damageObject ---

function StaticShapeData::damageObject(%data, %targetObject, %sourceObject, %position, %amount, %damageType)
{
   %targDB = %targetObject.getDataBlock().getName();

   //base items are invincible on offensive team, send a message to all who try
   if (%targetObject.team == Game.offenseTeam && (%targDB $= "StationInventory" || %targDB $= "GeneratorLarge" || %targDB $= "TurretBaseLarge") || (%data.noDamageInSiege && Game.class $= "SiegeGame"))
   {
      if(%sourceObject && %targetObject.isEnabled())
      {
         //if a player
         if(%sourceObject.client)
            messageClient(%sourceObject.client, 0, "\c5Offensive Base Equipment Invincible.~wfx/powered/station_denied.wav");
         //a shrike
         else if (%sourceObject.getDataBlock().catagory $= "Vehicles")
         {
            if(%sourceObject.getDatablock().numMountPoints > 0)
            {
               for(%i = 0; %i < %sourceObject.getDatablock().numMountPoints; %i++)
               {
                  if (%sourceObject.getMountNodeObject(%i) > 0)
                     messageClient( %sourceObject.getMountNodeObject(%i).client, 0, "\c5Offensive Base Equipment Invincible.~wfx/powered/station_denied.wav");
               }
            }
         }
         //or a bomber

         //else if (%sourceObject.getDataBlock().catagory $= "Turrets")
         //{
            //error("2 StaticShapeData::damageObject - it was a Turret");

            else if(%sourceObject.getDataBlock().getName() $= "BomberTurret")
            {
               error("3 StaticShapeData::damageObject - It was a bomberturret");

               %veh = %sourceObject.vehicleMounted;
               if(%veh.getDatablock().numMountPoints > 0)
               {
                  for(%i = 0; %i < %veh.getDatablock().numMountPoints; %i++)
                  {
                     if (%veh.getMountNodeObject(%i) > 0)
                        messageClient( %veh.getMountNodeObject(%i).client, 0, "\c5Offensive Base Equipment Invincible.~wfx/powered/station_denied.wav");
                  }
               }
            }
         //}
         //-----------------------------------------------------------------   
      }

      return;
   }

   Parent::damageObject(%data, %targetObject, %sourceObject, %position, %amount, %damageType);
}

//----------------------------------------------------------------------------------------- end ColdFront_Siege package ---***---
};




