//-------------------------------------------------------
//put everything back to default at mission end - Lagg...

function DefaultGame::gameOver( %game )
{
   //set the bool
   $missionRunning = false;

   CancelCountdown();
   CancelEndCountdown();
   
   //loop through all the clients, and do any cleanup...
   %count = ClientGroup.getCount();
   for (%i = 0; %i < %count; %i++)
   {
      %client = ClientGroup.getObject(%i);
      %player = %client.player;
      %client.lastTeam = %client.team;
      
      if ( !%client.isAiControlled() )
      {
         %client.endMission();
         messageClient( %client, 'MsgClearDebrief', "" );
         %game.sendDebriefing( %client );
         if(%client.player.isBomber)
            commandToClient(%client, 'endBomberSight');

         //clear the score hud...
         messageClient( %client, 'SetScoreHudHeader', "", "" );
         messageClient( %client, 'SetScoreHudSubheader', "", "");
         messageClient( %client, 'ClearHud', "", 'scoreScreen', 0 );
         
         // clean up the players' HUDs:
         %client.setWeaponsHudClearAll();
         %client.setInventoryHudClearAll();
      }
   }

   // Default game does nothing...  except lets the AI know the mission is over
   AIMissionEnd();

   //all this has to be done in the correct order or Crash, Bang, BOOM! $#&%
   error("DefaultGame::gameOver - resetting all files to server defaults");

   exec("scripts/aiSiege.cs");
   exec("scripts/aiCTF.cs");
   exec("scripts/aiDnD.cs");

   $InvBanList[Siege, "SatchelCharge"] = 0;

   // Load server data blocks
   //exec("scripts/commanderMapIcons.cs");
   //exec("scripts/markers.cs"); 
   //exec("scripts/serverAudio.cs");
   //exec("scripts/damageTypes.cs");
   //exec("scripts/deathMessages.cs");
   //exec("scripts/inventory.cs");
   exec("scripts/camera.cs");
   //exec("scripts/particleEmitter.cs");    // Must exist before item.cs and explosion.cs
   //exec("scripts/particleDummies.cs");
   exec("scripts/projectiles.cs");//- if bots enabled - NOTE        // Must exits before item.cs
   exec("scripts/player.cs");//- if bots enabled - NOTE
   //exec("scripts/gameBase.cs");
   exec("scripts/staticShape.cs");
   //exec("scripts/weapons.cs");
   exec("scripts/turret.cs");
   exec("scripts/weapTurretCode.cs");//- if bots enabled - NOTE
   //exec("scripts/pack.cs");
   //exec("scripts/vehicles/vehicle_spec_fx.cs");    // Must exist before other vehicle files or CRASH BOOM
   exec("scripts/vehicles/serverVehicleHud.cs");
   //exec("scripts/vehicles/vehicle_shrike.cs");
   exec("scripts/vehicles/vehicle_bomber.cs");//- if bots enabled - NOTE
   //exec("scripts/vehicles/vehicle_havoc.cs");
   //exec("scripts/vehicles/vehicle_wildcat.cs");
   exec("scripts/vehicles/vehicle_tank.cs");//- if bots enabled - NOTE
   exec("scripts/vehicles/vehicle_mpb.cs");//- if bots enabled - NOTE
   exec("scripts/vehicles/vehicle.cs");            // Must be added after all other vehicle files or EVIL BAD THINGS
   exec("scripts/ai.cs");//- if bots enabled - NOTE
         //includes - exec("scripts/aiDebug.cs");
         //includes - exec("scripts/aiDefaultTasks.cs");
         //includes - exec("scripts/aiObjectives.cs");
         //includes - exec("scripts/aiInventory.cs");
         //includes - exec("scripts/aiChat.cs");
         //includes - exec("scripts/aiHumanTasks.cs");
         //includes - exec("scripts/aiObjectiveBuilder.cs");
         //includes - exec("scripts/aiBotProfiles.cs");
   //exec("scripts/item.cs");
   exec("scripts/station.cs");
   //exec("scripts/simGroup.cs");
   //exec("scripts/trigger.cs");
   exec("scripts/forceField.cs");
   //exec("scripts/lightning.cs");
   //exec("scripts/weather.cs");
   //exec("scripts/deployables.cs");
   //exec("scripts/stationSetInv.cs");
   //exec("scripts/navGraph.cs");
   //exec("scripts/targetManager.cs");
   //exec("scripts/serverCommanderMap.cs");
   //exec("scripts/environmentals.cs");
   //exec("scripts/power.cs");
   exec("scripts/serverTasks.cs");//- if bots enabled - NOTE
   //exec("scripts/admin.cs");
   //exec("prefs/banlist.cs");

   deactivatePackage(LaggsDefault2_Support);
   error("Deactivating Package LaggsDefault2_Support");

   //we close our last package and we are done :)
   deactivatePackage(LaggsDefault2_GameType);
   error("Deactivating Package LaggsDefault2_GameType");
   //* Can't Use function defaultGame::gameOver in package if MapSupportPack is included in server files *

   exec("scripts/defaultGame.cs");//* HACK ALERT! - We Hacked around MapSupportPack Here :) *
   echo("Come Again Soon - Lagg... :)");
}