//----------------------------------------------- Custom ForceField Stuff ------------------------------------------------
//------------------------------------------------------------------------------------------------------------------------

//------------------------------------------------------------------------------------------ ForceFieldBareData::onAdd ---
function ForceFieldBareData::onAdd(%data, %obj)
{
   Parent::onAdd(%data, %obj);

   %velo = 0.1;
   %grav = 1.0;
   %appl = "0 0 0";

   if(%obj.custom $= "1")
   {
      %velo = %obj.velocityMod;
      %grav = %obj.gravityMod;
      %appl = %obj.appliedForce;
   }   

   %pz = new PhysicalZone() {
      position = %obj.position;
      rotation = %obj.rotation;
      scale    = %obj.scale;
      polyhedron = "0.000000 1.0000000 0.0000000 1.0000000 0.0000000 0.0000000 0.0000000 -1.0000000 0.0000000 0.0000000 0.0000000 1.0000000";
      velocityMod  = %velo;
      gravityMod   = %grav;
      appliedForce = %appl;
		ffield = %obj;
   };

   %pzGroup = nameToID("MissionCleanup/PZones");
   if(%pzGroup <= 0)
   {
      %pzGroup = new SimGroup("PZones");
      MissionCleanup.add(%pzGroup);
   }
   %pzGroup.add(%pz);
}

//------------------------------------------------------ AI ZONE STUFF ---------------------------------------------------
//------------------------------------------------------------------------------------------------------------------------

//--------------------------------------------------- Outside Zone ---------------------------------------------
//used only in siege game type outside defense base entrances
datablock TriggerData(outsideTrigger)
{
   tickPeriodMS = 50;
};

function outsideTrigger::onEnterTrigger(%data, %obj, %colObj)
{
   if (%colObj.client.isAIControlled() && %colObj.client.team == game.offenseTeam)
      %colObj.client.inBase = false;
}

function outsideTrigger::onLeaveTrigger(%data, %obj, %colObj)
{
   // do nothing
}

function outsideTrigger::onTickTrigger(%data, %obj)
{
  // do nothing
}

//--------------------------------------------------- Inside Zone ----------------------------------------------
//used only in siege game type in defense base entrances
datablock TriggerData(insideTrigger)
{
   tickPeriodMS = 50;
};

function insideTrigger::onEnterTrigger(%data, %obj, %colObj)
{
   if (%colObj.client.isAIControlled() && %colObj.client.team == game.offenseTeam)
      %colObj.client.inBase = true;
}

function insideTrigger::onLeaveTrigger(%data, %obj, %colObj)
{
   // do nothing
}

function insideTrigger::onTickTrigger(%data, %obj)
{
  // do nothing
}

//-------------------------------------------------- Death Trigger ----------------------------------------------
//used only in siege game type in offensive base entrances
datablock TriggerData(deathTrigger)
{
   tickPeriodMS = 50;
};

function deathTrigger::onEnterTrigger(%data, %obj, %colObj)
{
   if (%colObj.client.team != game.offenseTeam)
   {
      %pl = %colObj.client.player;
      if(isObject(%pl))
      {
         if(%pl.isMounted())
            %pl.getDataBlock().doDismount(%pl);
         %pl.scriptKill(0);
         messageClient(%colObj.client, 'MsgClient', 'You were killed for entering offensive base');
      }
   }
}

function deathTrigger::onLeaveTrigger(%data, %obj, %colObj)
{
   // do nothing
}

function deathTrigger::onTickTrigger(%data, %obj)
{
  // do nothing
}
